/*
 Nome C-Robot : Mancino.r
 
 Autore : Lamberto Leoncavallo (classe 72)
 
 E-Mail : lleoncavallo@racine.ra.it
 
 Questo  il robot di esordio per me in una competizione per C-Robots. Scusatemi quindi per la 
 semplicit dell'algoritmo che vi andr a spiegare a breve. Il nome del Robot deriva dal nome che 
 ho associato ad un mio giocatore in una competizione di Tennis virtuale chiamata Tennis Pro 
 Tournament (TpT per gli amici) nel quale si deve descrivere con un linguaggio particolare il
 comportamento del proprio giocatore. A sua volta in quell'occasione scelsi il nome Mancino per
 la semplice ragione che sono "mancino" e non "destro". (Scusate la banalit...) Se siete curiosi
 andate a visitare la Web Page del TpT all'indirizzo : 
 
 http://space.tin.it/io/rpaci
 
 Giusto per completezza la competizione  organizzata da Alex Paci che partecipa a questa edizione
 del torneo di C-Robots. A proposito, buona fortuna Alex ;-)
 Scusate la "publicit" e torniamo alle cose serie.
 
 
COMPORTAMENTO DEL ROBOT :

Questo, essendo il mio primo robot  molto semplice.
Ad inizio match conoscendo la pericolosit del centro arena
Mancino cerca riparo vicino alle pareti dell'arena e quindi
individua la parete pi prossima e vi si dirige alla massima
velocit. Ivi giunto in pratica inizia quella che sar la sua
routine per tutto il match e cio percorre tutto il perimetro
dell'arena in modo ripetitivo alla massima velocit. Particolarit
rilevanti a mio avviso di questa corsa sono :

1) Senso di rotazione. Ho notato che contro molti avversari la
rotazione oraria porta ad una maggiore efficienza rispetto a quella
antioraria, probabilmente a causa degli algoritmi di scanning usati
dalla maggior parte dei Robots. Quindi Mancino ruota in senso orario.

2) La distanza dal muro che  superiore ai 100 "metri". Questo permette 
al mio robot di percorrere traiettorie sfalsate rispetto ad altri robot
che preferiscono una maggior vicinanza alle pareti e quindi penso che lo renda pi "sfuggente". (E' una mia teoria priva di ogni fondamento dimostrabile...)

3) La rotazione continua permette al mio robot di raggiungere senza problemi con il suo sparo qualsiasi punto dell'arena e quindi impedisce qualsiasi rischio di patta. Questo mi pare un fattore positivo visto che una eventuale vittoria viene pagata 3 volte pi della patta. Un p come nel calcio una patta  una mezza sconfitta. (Lo stesso fattore  molto negativo nella fase iniziale, ma questo giocatore  volutamente rozzo)

Infine ovviamente Mancino non dimentica di sparare senza piet a qualsiasi oggetto rientri nel suo range di sparo.

Questo  tutto. 

Bye
 
*/

int dist, /* Imposta la distanza alla quale iniziare a frenare per impostare la curva in prossimit dei muri */
    direzione, /* Indica la direzione nella quale si muove il Robot */
    /* Usate nella routine di sparo */
    mira,
    miraPrec,
    range,
    rangePrec;

/*
Semplice funzione aritmetica che implementa il calcolo 
del valore assoluto dell'argomento "a" passatele restituendo
il risultato come valore di ritorno.
*/
int abs(a)
int a;
{
 if (a<0) return(a*(-1));
 return a;
}

/*
Questa funzione viene chiamata per impostare la direzione nella quale il robot
si deve muovere allo start. In particolare il robot sceglie di andare verso il
muro pi vicino scegliendo la traiettoria pi breve e quindi quella perpendicolare
al muro. In pratica questa funzione imposta la variabile "direzione" con la
direzione desiderata
*/
sceltadir()
{
 if (abs(500-loc_x())>abs(500-loc_y()))
  if (loc_x()<500) direzione = 180;
  else direzione = 0;
 else if (loc_y()<500) direzione = 270;
      else direzione = 90;
}

/*
Di questa routine non posso andare fiero personalmente, in quanto  un adattamento
della routine di sparo utilizzata da Goblin nell'ultima edizione con qualche piccolo
correttivo.
*/
spara()
{
    if (rangePrec=scan(mira,10))
    {
        if (!scan(mira-=5,5)) mira+=10;
        if (rangePrec>700)
        {
		 mira+=40;
		 return;
        }

        if(scan(mira-5,1)) mira-=5;
        if(scan(mira+5,1)) mira+=5;
        if(scan(mira-3,1)) mira-=3;
        if(scan(mira+3,1)) mira+=3;
        if(scan(mira-1,1)) mira-=1;
        if(scan(mira+1,1)) mira+=1;

        if (rangePrec=scan(miraPrec=mira,5))
        {
            if(scan(mira-5,1)) mira-=5;
            if(scan(mira+5,1)) mira+=5;
            if(scan(mira-3,1)) mira-=3;
            if(scan(mira+3,1)) mira+=3;
            if(scan(mira-1,1)) mira-=1;
            if(scan(mira+1,1)) mira+=1;

            if (range=scan(mira,10))
            { cannon(mira+(mira-miraPrec)*((1200+range)>>9)-(sin(mira-direzione)>>14),
                       range*160/(160+rangePrec-range-(cos(mira-direzione)>>12)));
            }
        }
     }
     else
     {
        if (scan(mira-=20,10)) return;
        if (scan(mira+=40,10)) return;
        mira+=40; return;
     }
}

main ()
 {
   dist = 150 ; /*Distanza di staccata */
   vaila () ;
   while (1) corri() ;
 }

/*
Questa routine gestisce il transitorio iniziale e cio la fase precedente al ciclo infinito che seguir.
L'obiettivo di questa routine  portare il robot nell'angolo in alto a sinistra. Per fare questo il
robot prima viene diretto verso il muro pi vicino e poi inizia il movimento che lo caratterizzer
durante tutto il torneo, cio inizia a percorrere tutto il perimetro dell'arena in senso orario fino
ad arrivare nell'angolo in alto a sinistra. Durante la sua folle corsa ai "100 all'ora" il robot  alla
continua ricerca di avversari a portata di sparo (<700) da potere colpire e possibilmente distruggere.
*/ 
 vaila ()
 {
  sceltadir();
   if (direzione==0)
  {
   while (loc_x() < (999-dist)) {drive (0,100); spara();}
   drive (270,0) ;
   while (speed()>49) ;
   direzione = 270;
  }
  if (direzione==270)
  {
   while (loc_y() > dist) {drive (270,100); spara();}   
   drive (180,0) ;
   while (speed()>49) ;
   direzione = 180;
  }
  if (direzione==180)
  {
   while (loc_x() > dist) {drive (180,100);  spara();}   
   drive (90,0) ;
   while (speed()>49) ;
   direzione = 90;
  } 
  if (direzione==90)
  {
   while (loc_y() < (999-dist)) {drive (90,100);  spara();}   
   drive (0,0) ;
   while (speed()>49) ;
  }
 }


/*
L'esecuzione di questa routine comporta l'esecuzione di un giro completo di campo in senso orario
a partire dall'angolo in alto a sinistra per arrivare all'angolo in alto a sinistra. Anche qui 
durante la corsa il robot  alla continua ricerca di bersagli.
*/ 
 corri ()
{
  while (loc_x() < (999-dist)) {drive (direzione=0,100); spara();}
  drive (270,0) ;
  while (speed()>49) ;
  while (loc_y() > dist) {drive (direzione=270,100); spara();}   
  drive (180,0) ;
  while (speed()>49) ;
  while (loc_x() > dist) {drive (direzione=180,100);  spara();}   
  drive (90,0) ;
  while (speed()>49) ;
  while (loc_y() < (999-dist)) {drive (direzione=90,100);  spara();}   
  drive (0,0) ;
  while (speed()>49) ;
 }

