/*  PatCioca CRobot   Roma 31/08/94  */

/*  Scorre l' arena secondo una traiettoria verticale 
    lungo il margine destro della arena fermandosi agli angoli.
    La routine di fuoco e' ottimizzata sia rispetto
    alla gittata che rispetto all'angolo ed e' ricavata
    dal precedente robot Poirot.r.

    Cristiano De Mei   L.go A. Beltramelli 36  00157 Roma
                       Tel. 06 - 41732181
*/

int ang,rp,dprec,angini,angfin,ra,distanza,nonhosparato,continua,angp;
main()
{
  ang=0;angp=0;
  while (loc_x()<940) { drive(0,100);fuocoright(); }
  drive(0,49);
  while (loc_x()<980) fuocoright();
  while (loc_x()<990) { drive(0,19);fuocoright(); }
  drive(180,0);
  if (loc_y()>900) drive(270,25);     /* evita di urtare un muro */
              else drive(90,25);
  while (speed()>49) fuocoright();
  drive(270,49);ang=270;

  while(1)
  {   
     while (loc_y()>100) fuocoright();     /* spostamento in giu */
     drive(270,49);
     while (loc_y()>30) fuocoright();
     drive(90,0);
     angini=90;angfin=181;
     angolo();

     drive(90,100);ang=90;                /* spostamento in su */
     while (loc_y()<900) fuocoright();
     drive(90,49);
     while (loc_y()<970) fuocoright();
     drive(270,0);
     angini=180;angfin=271;
     angolo();

     drive(270,100);ang=270;
  }
}

angolo()   /* routine di fermata e ricerca dell'avversario */
{

  dprec=damage();
  ang=angini;
  while (damage()<dprec+11)
  {
    if ((ra=scan(ang,10)) && (ra<775))
    {
      continua=1;
      while ((continua) && (damage()<dprec+11))
      {
        ang+=(scan(ang+13,2) != 0)*15;
        ang+=(scan(ang-13,2) != 0)*345;
        spara();
      }
      continua=1;
      while ((continua) && (damage()<dprec+11))
      {
        ang+=(scan(ang+8,2) != 0)*10;
        ang+=(scan(ang-8,2) != 0)*350;
        spara();
      }
      continua=1;
      while ((continua) && (damage()<dprec+11))
      {
        ang+=(scan(ang+3,2) != 0)*5;
        ang+=(scan(ang-3,2) != 0)*355;
        spara();
      }
    }
    else
    {
      ang+=10;
      ang%=360;
      if (ang>angfin) ang=angini;
    }
  }
}

spara()  /* aggiusta il tiro ... */
{
      if (ra=scan(ang,3))
      {
        if ((rp-ra>160) || (ra-rp>160)) distanza=ra;
        else
          if (ra>rp+5) distanza=ra*8/7;
          else
            if (ra<rp-5) distanza=ra*7/8;
            else distanza=ra;
        nonhosparato=bomba();
        rp=ra;
        continua=(angp!=ang);
        angp=ang;
      }
      else continua=0;
}

bomba()  /* ... e fuoco ! */
{
  return !(cannon(ang,distanza));
}


fuocoright()  /* routine di fuoco durante le manovre */
{
  int range,ra;

  if (range=scan(ang,8))
  {
    if (ra=scan(ang,2))
    {
      if (ra>rp+15) cannon(ang,8*ra/7);
      else
      if (ra<rp-15) cannon(ang,7*ra/8);
      else
      cannon(ang,ra);
      rp=ra;
    }
    else
    if (ra=scan(ang+4,3))
    {
      if (ra>rp+15) cannon(ang+5,8*ra/7);
      else
      if (ra<rp-15) cannon(ang+5,7*ra/8);
      else
      cannon(ang+5,ra);
      rp=ra;
      ang+=4;
    }
    else
    if (ra=scan(ang-4,3))
    {
      if (ra>rp+15) cannon(ang-5,8*ra/7);
      else
      if (ra<rp-15) cannon(ang-5,7*ra/8);
      else
      cannon(ang-5,ra);
      rp=ra;
      ang+=350;
    }
  }
  else
  {
    ang+=12;
    ang%=360;
    if (ang>271) ang=90;
  }
}
